<?php
// require config.php!
class ContentHandler
{
	private $_defaultPath;
	private $_filePath;
	private $_templateHtml;
	private $_title;
	private $_content;
	private $_newTemplateHtml;
//	private $_siteTitleFile;
	private $_siteTitle;
	
	function __construct($str_path)
	{
		global $ne2_config_info;
		
//		$this->_siteTitleFile = $_SERVER['DOCUMENT_ROOT'] . '/vkapp/NavEditor2/data/title.txt';
//		$this->_defaultPath = $_SERVER['DOCUMENT_ROOT'] . '/vkapp/NavEditor2/data/templates/seitenvorlage.html';
		$this->_defaultPath = $ne2_config_info['app_path'] . 'data/templates/seitenvorlage.html';
		$this->_newTemplateHtml = '';
		$this->_siteTitle = $ne2_config_info['current_site_title'];
		
		$this->_filePath = $str_path;
		if(file_exists($this->_filePath)) {
			if(($this->_templateHtml = file_get_contents($this->_filePath)) == FALSE) {
				throw new Exception('Unable to open file: ' . $this->_filePath);
			}
		} else { // try default path
			if(($this->_templateHtml = file_get_contents($this->_defaultPath)) == FALSE) {
				throw new Exception('Unable to open file: ' . $this->_filePath);
			}
		}
		
/*		if(file_exists($this->_siteTitleFile)) {
			if(($this->_siteTitle = trim(file_get_contents($this->_siteTitleFile))) == FALSE) {
				throw new Exception('Unable to open Site-Title File!');
			}
		}*/
	}
	
	public function setContents($newTitle, $newContent)
	{
		$this->_title = $newTitle;
		$this->_content = $newContent;
	}
	
	private function replaceTitles()
	{
		// <title>...</title>
		$pattern1 = '/<title>((.)*?)<\/title>/i';
		$this->_templateHtml = preg_replace($pattern1, '<title>' . $this->_siteTitle . '_' . $this->_title . '</title>', $this->_templateHtml);
		
		// <h1>...</h1>
		$pattern2 = '/(<div id="titel">)((\n|.)*?)(<\/div>)/i';
		$this->_templateHtml = preg_replace($pattern2, '$1<h1>' . $this->_title . '</h1>$4', $this->_templateHtml);
	}
	
	private function replaceContent()
	{
		$str_pattern = '/(<a name="contentmarke" id="contentmarke"><\/a>)((\n|.)*?)(<hr id="vorfooter" \/>)/i';
		$this->_templateHtml = preg_replace($str_pattern, '$1' . $this->_content . '$4', $this->_templateHtml);
	}
	
	// Do the replacement
	public function ReplaceContents()
	{
		$this->replaceTitles();
		$this->replaceContent();
		
		$bakstr = '_' . date('YmdHis') . '.shtml';
		$newPath = $this->_filePath . $bakstr;
		// backup
		if(!copy($this->_filePath, $newPath)) {
			throw new Exception('Unable to create backup file!');
		}
		file_put_contents($this->_filePath, $this->_templateHtml);
	}
	
	public function GetContentHtml()
	{
		$pattern = '/(<a name="contentmarke" id="contentmarke"><\/a>)((\n|.)*?)(<hr id="vorfooter" \/>)/i';
		preg_match($pattern, $this->_templateHtml, $matches);
		// error
		if(count($matches) < 3) {
			return '<span style="color:red;">INFO: No content tag found, this page is possibly not produced from templates.</span>';
		}
		return $matches[2];
	}
}
?>